; hacker port firmware
; version 0.2 date 2004-05-22
; part of the hacker port project - http[s]://1stein.schuermans.info/hackerport/
; Copyright (C) 2003-2004 1stein <1stein@schuermans.info>
; Copyleft: GNU public license - http://www.gnu.org/copyleft/gpl.html

	TITLE		"debug procedures for hackerport firmware"

	include		"P18F442.INC"



;===========================================================================================
; imported variables
;===========================================================================================



;===========================================================================================
; imported procedures
;===========================================================================================



;===========================================================================================
					; constants
;===========================================================================================

; length of debug buffer
DEBUG_BUF_LEN	equ	0x80



;===========================================================================================
accessram	UDATA_ACS		; access RAM
;===========================================================================================

DEBUG_REG	res		1		; general purpose register for debug
DEBUG_BUF_POS	res		1		; position in debug buffer
DEBUG_FSR0	res		2		; backup register for FSR0



;===========================================================================================
ram_debug	UDATA				; normal RAM for debug
;===========================================================================================

DEBUG_BUF	res		DEBUG_BUF_LEN	; buffer to store debug information



;===========================================================================================
prog		CODE			; normal code
;===========================================================================================

;-------------------------------------------------------------------------------------------
; debug initialization
;-------------------------------------------------------------------------------------------
DEBUG_INIT:
; clear debug buffer
	clrf	DEBUG_BUF_POS
; done
	return

;-------------------------------------------------------------------------------------------
; log debug information
; input:	WREG		byte to log
; output:	-
; changes:	WREG, STATUS
;-------------------------------------------------------------------------------------------
DEBUG_LOG:
; save debug data
	movwf	DEBUG_REG
; clear buffer if it is full
	movlw	DEBUG_BUF_LEN
	cpfslt	DEBUG_BUF_POS
	clrf	DEBUG_BUF_POS
; save FSR0
	movff	FSR0L,DEBUG_FSR0+0
	movff	FSR0H,DEBUG_FSR0+1
; calculate address of current position in debug buffer
	movlw	low DEBUG_BUF
	addwf	DEBUG_BUF_POS,W
	movwf	FSR0L
	movlw	high DEBUG_BUF
	clrf	FSR0H
	addwfc	FSR0H
; write debug data into debug buffer
	movff	DEBUG_REG,INDF0
; restore FSR0
	movff	DEBUG_FSR0+0,FSR0L
	movff	DEBUG_FSR0+1,FSR0H
; increment position in debug buffer
	incf	DEBUG_BUF_POS
; done
	return



;===========================================================================================
; global variables
;===========================================================================================
	global		DEBUG_BUF, DEBUG_BUF_POS



;===========================================================================================
; global procedures
;===========================================================================================
	global		DEBUG_INIT, DEBUG_LOG



	end
